<template>
  <Pagination
    v-if="displaySecondPagination"
    :maxPages="maxPages"
    v-model="currentPage"
  />

  <div class="main">
    <ProjectCard
      class="m-6"
      v-for="project in paginatedItemsToDisplay"
      :key="project.data.id"
      :project="project"
    />
  </div>

  <Pagination
      :maxPages="maxPages"
      v-model="currentPage"
    />
</template>

<script>
import ProjectCard from './ProjectCard.vue'
import Pagination from './Pagination.vue'

import { ref, watch, computed } from 'vue'

export default {
  name: 'ListProjectCard',
  components: {
    ProjectCard,
    Pagination
  },
  props: {
    projects: {
      type: Array,
      default: []
    },
    numberOfItems: {
      type: Number,
      default: 1
    }
  },
  setup (props) {
    const currentPage = ref(1)
    let first = computed(() => ((currentPage.value - 1) * props.numberOfItems))
    let maxPages = computed(() => {
      if (props.projects.length === 0) {
        // Be sure to have a valid value even if project list is empty.
        return 1
      } else {
        return Math.ceil(props.projects.length / props.numberOfItems)
      }
    })

    // Display projects starting page 1 when user changes the item list
    watch(
      () => props.projects,
      () => {
        currentPage.value = 1
      },
    )

    const showPaginatedItemsList = () => {
      let paginatedItemsList = []
      for (let i = first.value; i < first.value + props.numberOfItems; i++) {
        if (i >= 0 && i < props.projects.length) {
          paginatedItemsList.push(props.projects[i])
        }
      }
      return paginatedItemsList
    }

    let paginatedItemsToDisplay = computed(() => {
      return showPaginatedItemsList()
    })

    const displaySecondPagination = computed(() => (props.numberOfItems > 3))

    return {
      currentPage,
      maxPages,
      paginatedItemsToDisplay,
      displaySecondPagination
    }
  }
}
</script>

<style lang="postcss" scoped>
.main {
  @apply flex flex-wrap justify-center;
}
</style>